SystemOrganization addCategory: #'Seaside-Cache-NG'!

WAObject subclass: #WACacheEntryNG
	instanceVariableNames: 'key keyHash value next byAccessListEntry byCreationListEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

WAObject subclass: #WACacheListEntryNG
	instanceVariableNames: 'previous next time cacheEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

WAObject subclass: #WACacheNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:17'!
at: aKey ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:15'!
at: aKey put: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:19'!
keyAtValue: anObject ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'enumerating' stamp: 'pmm 8/26/2012 12:04'!
keysAndValuesDo: aTwoArgumentBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'removing' stamp: 'pmm 8/26/2012 12:16'!
remove: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'removing' stamp: 'pmm 8/26/2012 12:06'!
removeAll
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:49'!
store: anObject
	"Store anObject in the cache, generating a new random key. Return the key."
	self subclassResponsibility! !

WACacheNG subclass: #WAHashCacheNG
	instanceVariableNames: 'table size maximumSize overflowAction byAccessRoot byCreationRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 8/26/2012 12:47'!
includesKey: aKey
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 8/26/2012 12:33'!
performOverflowAction
	self notYetImplemented! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:53'!
store: anObject
	| candidateKey |
	[ 
		candidateKey := WAKeyGenerator current keyOfLength: self keySize.
		self includesKey: candidateKey ] whileTrue.
	self at: candidateKey put: anObject.
	^ candidateKey! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 8/26/2012 12:33'!
sweepIncrementally
	self notYetImplemented! !

WACacheNG subclass: #WAMutualExclusionCacheNG
	instanceVariableNames: 'mutex cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAMutualExclusionCacheNG class methodsFor: 'instance creation' stamp: 'pmm 8/26/2012 12:08'!
on: aCache
	^ self basicNew initializeOn: aCache; yourself! !

!WAMutualExclusionCacheNG methodsFor: 'initialization' stamp: 'pmm 8/26/2012 12:07'!
initializeOn: aCache.
	self initialize.
	mutex := WAMutex new.
	cache := aCache! !

!WAMutualExclusionCacheNG methodsFor: 'removing' stamp: 'pmm 8/26/2012 12:09'!
removeAll
	^ mutex critical: [
		cache removeAll ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:48'!
store: anObject
	^ mutex critical: [
		cache store: anObject ]	! !
